import { Rehydrater } from 'Rehydraters';
/**
 * Caches the property value in Memory.
 *
 * A function should be specified to generate a unique string
 * key for this instance. For example:
 *
 * ```
 * class CachedContainer {
 *   constructor(public id: Id<StructureContainer>) {}
 *
 *   @memoryCache((i: CachedContainer) => i.id)
 *   public structureType?: StructureConstant
 * }
 * ```
 *
 * Some helper key functions are provided such as `keyById`
 * (equivalent to the above).
 */
export declare const memoryCache: (key: (instance: any) => string, rehydrater?: Rehydrater) => (target: unknown, propertyKey: string) => void;
